/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
  Programa para limitar o numero de emails env.                        
  por cliente                                                          
  Programado por Lucas Priori                                          
                                                                       
  Para compilar este programa:                                         
  gcc sceo_rquota.c -o sceo_rquota -lmysqlclient                       
                                                                       
  ******************************************************************   
  Copyright (C) 2008  Lucas Priori                                     
                                                                       
  This program is free software: you can redistribute it and/or modify 
  it under the terms of the GNU General Public License as published by 
  the Free Software Foundation, either version 3 of the License, or    
  (at your option) any later version.                                  
                                                                       
  This program is distributed in the hope that it will be useful,      
  but WITHOUT ANY WARRANTY; without even the implied warranty of       
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        
  GNU General Public License for more details.                         
                                                                       
  You should have received a copy of the GNU General Public License    
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<mysql/mysql.h>


#define VERSAO "0.1"
#define HOST "localhost"
#define DB "sceo_rquota"
#define USER "sceo"
#define PASS "senhamudar"
#define TABLE "rquota"
#define USER_FIELD "usuario"
#define SENT_FIELD "enviados"
#define QUOTA_FIELD "quota"
#define TAM_buffer 1024
#define QUOTA_padrao 1000


/************ Programa Principal **************/
int main(int argc,char *argv[]){
 MYSQL *mysql = NULL;
 MYSQL_RES *myres; 
 MYSQL_ROW myreg;
 
 char cmd_sql[512];
 char usuario[TAM_buffer]={0};
 char existe=0;
 char arg_c=0;
 unsigned int arg_d=QUOTA_padrao;
 unsigned int arg_a=0;
 unsigned int arg_z=0;
 unsigned int cont1=0;
 unsigned int num_cmds=0;
 unsigned int sent=0;
 unsigned int quota=0;
 
 if(argc<2){
  Ajuda:
  printf("\nSceo_rquota V %s\n",VERSAO);
  printf("Comandos | Descricao \n");
  printf("   -c     - Checa se o usuario ja passou sua quota\n");
  printf("            Ex: ./sceo_rquota -c -u fulano\n");
  printf("   -a     - Atualiza a base de dados com o numero de\n");
  printf("            e-mails enviados na atual conexao ou cria\n");
  printf("            o usurio utilizando o -d como limite de quota padro\n");
  printf("            ou o valor %d caso no -d no seja especificado\n",QUOTA_padrao);
  printf("            Ex: ./sceo_rquota -a 15 -u fulano\n");
  printf("            Ex: ./sceo_rquota -a 32 -u beltrano\n");
  printf("   -d     - Cria o usuario no banco de dados se nao existir\n");
  printf("            definindo a quota do mesmo\n");
  printf("            Ex: ./sceo_rquota -d 2000 -a 5 -u fulano\n");
  printf("            Obs: Este comando s funciona junto com o '-a'\n");
  printf("   -u     - Para especificar o usuario\n");
  printf("   -z     - Zera o numero de emails enviados de todos os usuarios\n");
  printf("            ou o usuario especificado por -u\n");
  printf("\n Este programa retorna o valor 0 (ZERO) caso o usuario\n");
  printf("ainda nao tenha atingido a quota de numero de emails enviados\n");
  printf("ou o valor 1 caso contrario\n");
  printf("\n");
  return 0;
 }
 /* =-=-=- Pegando os parametros =-=-=- */
 for(cont1=1;cont1<argc;cont1++){
  if(!strcmp(argv[cont1],"-c")){
   arg_c=1;
   num_cmds++;
  }else if(!strcmp(argv[cont1-1],"-a")){
   arg_a=atoi(argv[cont1]);
   num_cmds++;
  }else if(!strcmp(argv[cont1-1],"-d")){
   arg_d=atoi(argv[cont1]);
   num_cmds++;
  }else if(!strcmp(argv[cont1-1],"-u")){
   strncpy(usuario,argv[cont1],TAM_buffer);         /* Pegando o usuario */
  }else if(!strcmp(argv[cont1],"-z")){
   arg_z=1;
  }
 }
 if((!num_cmds || !usuario[0]) && !arg_z)goto Ajuda;          /* Esta faltando parametro */
 /* =-=-=- Conexao com o banco de dados =-=-=- */
 mysql = mysql_init(NULL);
 if(!mysql){
  printf("Nao foi possivel iniciar as funes do Mysql\n\n");
  return 0;  // Retornando ZERO para no bloquear o usuario em um eventual problema com o banco de dados
 }
 if(mysql_real_connect(mysql,HOST,USER,PASS,DB,0,NULL,0)){
  if(arg_z){
   /* Zerando o numero de emails enviados de todos os usuarios */
   if(usuario[0])snprintf(cmd_sql,sizeof(cmd_sql),"UPDATE %s SET %s=0 WHERE %s='%s'",TABLE,SENT_FIELD,USER_FIELD,usuario);
   else snprintf(cmd_sql,sizeof(cmd_sql),"UPDATE %s SET %s=0",TABLE,SENT_FIELD);
   mysql_query(mysql,cmd_sql);
   mysql_close(mysql);
   return 0;
  }
  /* CONECTADO */
  snprintf(cmd_sql,sizeof(cmd_sql),"SELECT %s,%s FROM %s WHERE %s='%s'",SENT_FIELD,QUOTA_FIELD,TABLE,USER_FIELD,usuario);
  existe=0;
  if(!mysql_query(mysql,cmd_sql)){
   myres=mysql_store_result(mysql);
   if((myreg=mysql_fetch_row(myres))!=NULL){
    existe=1;
    sent=atoi(myreg[0]);
    quota=atoi(myreg[1]);
   }
   mysql_free_result(myres);
  }
  if(arg_c && existe){
   if(sent>=quota){
    /* Usuario ultrapassou a quota */
    mysql_close(mysql);
    return 1;
   }
  }
  if(arg_a){
   if(!existe){
    /* Usuario nao existe  */
    /* Cadastrando usuario */
    snprintf(cmd_sql,sizeof(cmd_sql),"INSERT INTO %s (%s,%s,%s) VALUES ('%s','%d','%d')",TABLE,USER_FIELD,SENT_FIELD,QUOTA_FIELD,usuario,arg_a,arg_d);
    mysql_query(mysql,cmd_sql); 
   }else {
    snprintf(cmd_sql,sizeof(cmd_sql),"UPDATE %s SET %s=%s+%d WHERE %s='%s'",TABLE,SENT_FIELD,SENT_FIELD,arg_a,USER_FIELD,usuario);
    mysql_query(mysql,cmd_sql);
   }
  }
 }else printf("Nao foi possivel conectar no banco de dados\n");
 mysql_close(mysql);
 return 0;
}

